
% A덷@
% Ǎ덷ŏƂȂ悤ɐ؏o߂T30Zo

function [cfband, RT30, data] = T30s_RegErr11(ir, fs)

%%@===========================================
% -  -
% ir		: CpXԔg`
% fs        : TvOg
%
% - o -
% cfband    : IN^[uoh̒Sg
% RT30	    : Ή T30 
% data      : plot pf[^
%
% 2018.9.10 Coded by Y. Iiyama & Y. Kaneda, TDU

%%@===========================================

% --- CpX擪̌oi0̌oƐݒj
maxIR = max(ir.^2);		    % ir.^2 ̍ől擾
fstIRidx = find(ir.^2 > maxIR*0.01, 1); % ŏɁAől -20dBƂȂ_
ir = ir(fstIRidx:end);      % 擪̕ύX

% --- IN^[uoh ---
% [32, 63, 125, 250, 500, 1k, 2k, 4k, 8k, 16k] 10ohɕ

BandIRs = OctBndFilt01(ir);  % IN^[uohtB^O
fRange = 3:8;                % ́A125-4kHz 6oh 
                             %i63-8kHz 8шɂꍇ́A2:9j
cfband = 125*2.^(fRange-3);  % IN^[uoh̒Sg

% --- 
end_dB = -30;  % B̃p[^A
% GxāAI[̉AؕЂȏɂȂI[͖

RT30 = zeros(1,length(fRange));

for ii = 1:length(fRange)  % eIN^[uohɌvZ
    
    ir = BandIRs(:,ii+fRange(1)-1);   % IN^[uoh ir ϐ ir 
    
    % --- A덷ŏ ir  T30 ߂ -----
    
    [T30opt, data] = T30_opt11(ir);	  % T30
    RT30(ii) = T30opt/fs;             % T30 ̒Pʂ Tv  b ɕϊ

   %% === \ ========================
    % ȉ͌vZߒȂǂ̕\ł
    % KvɉāARgIItāAgpĂ

    % fig.12: ш悲Ƃ̃CpXup[ƉA
    % fig.13: ؏oшʃCpXvZcȐƉA
    % ȏQ́AT30 vZĂ邩̊mFł܂B

    % fig.14: e؏oɑ΂A덷
    % fig.15: e؏oŎZo T30
   
    % --- \pf[^
    minErrIdx = data{1}; Perrs = data{2}; T30s = data{3}/fs;
    enddB = data{4}; extRange = data{5}/fs; pp = data{6}; 

    % --- ir ̒Zԃp[\
    figure(12);subplot(2,3,ii)
    ir2 = ir.^2;
    LMA = fs * 0.01;                    % ړϒ
    ir2ma = conv(ir2,ones(LMA,1))/LMA;  % ړ
    ir2ma = ir2ma(LMA/2+1:LMA/2+length(ir2)); % Ԏ
    ir2ma = ir2ma/max(ir2ma);           % őlP
    plot((1:length(ir2ma))/fs, 10*log10(ir2ma)); grid on; hold on;  
    mylabel([num2str(cfband(ii)),' Hz band'], '(b)','up[ dB')
    plot([0,RT30(ii)],[0, -60],'r');    % Ȁdˏ
    ylim([-100,0]); drawnow

    % --- œKcȐƉA
    figure(13); subplot(2,3,ii);
    iropt = ir(1:round(extRange(minErrIdx)*fs)); % œKŐ؏o
    if size(iropt,1) < size(iropt,2); iropt = iropt'; end  % iropt cxNgɂ
    EDC = flipud(cumsum(flipud(iropt).^2) /sum(iropt.^2));  % cȐiCpX̂Qtϕ & Kj

    plot((1 : length(EDC)) ./ fs, 10*log10(EDC));  % cȐ̕`
    grid on; hold on; ylim([-80,0]); xlim([0,length(ir)/fs])
    mylabel([num2str(cfband(ii)),' Hz band'], ' (s)', 'cx (dB)')
    plot([1, length(EDC)] ./ fs, [-35, -35],'r--')
    cc = length(ir);
    plot([0,cc]/fs, [pp(2), pp(1)*cc+pp(2)],'g')

%     % --- ؏oƉA덷
%     figure(14); b1 = plot(extRange, 10*log10(Perrs)); grid on; hold on;
% %     Perrs(enddB>end_dB) = inf; plot(extRange, 10*log10(Perrs), 'LineWidth',3); 
%     % 		b1.FaceColor = 'flat'; b1.CData(minErrIdx, :) = [1, 0, 0];
%     mylabel('e؂oԂɑ΂A덷', '؂o (s)', '덷 (dB)');
% %     plot(extRange, enddB/10*(2),'r');   % A̐؏oł̒l(/5) -6 = -30dB
% %     plot([extRange(1),extRange(end)],[end_dB/5,end_dB/5],'r--')
%     
%     % --- T30 \
%     figure(15); b2 = plot(extRange, T30s*1000); grid on; hold on;
%     % 		b2.FaceColor = 'flat'; b2.CData(minErrIdx, :) = [1, 0, 0];
%     mylabel('e؂oԂŎZoT_{30}', '؂o (s)', 'cT_{30} (ms)')
% %     plot([extRange(minErrIdx), extRange(minErrIdx)],[0,4000],'--r')
    
   
end

% figure(14); legend([num2str(cfband(1)),'Hz'],[num2str(cfband(2)),'Hz'],...
%         [num2str(cfband(3)),'Hz'],[num2str(cfband(4)),'Hz'],...
%         [num2str(cfband(4)),'Hz'],[num2str(cfband(6)),'Hz'])
% figure(15); legend([num2str(cfband(1)),'Hz'],[num2str(cfband(2)),'Hz'],...
%         [num2str(cfband(3)),'Hz'],[num2str(cfband(4)),'Hz'],...
%         [num2str(cfband(4)),'Hz'],[num2str(cfband(6)),'Hz'])

% %% ==== T30 Zoʂ̕\
%  main  plot Ɠ́B 
% % --- T30 Ot
% figure(11)
% loglog(cfband,RT30(fRange-fRange(1)+1),'-o');
% ylim([0.1,5]);xlim([50,10000]);grid on
% title('T30'); xlabel('g (Hz)'); ylabel('T30 (s)');
% 
% % --- }ɐlL
% for ii = 1:length(cfband)
%     text(cfband(ii), RT30(ii)-0.5,num2str(round(RT30(ii) *100)/100),...
%         'FontSize',14, 'HorizontalAlignment','center')
% end

% gfigure([11,12,13,14,15])
gfigure([11,12,13])  % }ׂĕ\֐ł
